#!/usr/bin/perl
# use utf8;
# binmode STDIN,  ":utf8";
# binmode(STDOUT,":utf8"); 
#=====================================================================
#===  お問合せフォーム                    ===
#===  Copyright 2006,Programming by Studio iNDEX　　　　　　　　　 ===
#===  Copyright 2018,Programming by Studio iNDEX　　　　　　　　　 ===
#===                                           Date 2006 / 5 /  8  ===
#=====================================================================
#どのような用途であっても,本プログラム中の一部または全部の流用を禁ずる
#=====================================================================
#SendMailのパス
$sendmail = '/usr/sbin/sendmail';


#送信元アドレスリスト
my @mailList = ('soumu@ascend.co.jp','soumu@ascend.co.jp','soumu@ascend.co.jp');
my $adfmail;

#メールタイトルリスト（会社側）
my @titleList =('【営業案内に関するお問合せ】ホームページより問合せを承りました。','【採用に関するお問合せ】ホームページより問合せを承りました。','【その他】ホームページより問合せを承りました。');
my $subject;

#メールのタイトル（お客様側）
my $subject2 = "株式会社アセンド「お問合せ内容のご確認」";

#自分自身のファイル名
my $owncgi 	= "index.cgi";

#ルートからのアドレス（最後に「/」は入れないでください）
#$home = "..";

#UTF-8変換
use Encode::Guess qw/ shiftjis euc-jp 7bit-jis /;
use Encode qw/ from_to /;
#エラー出し用
#use CGI::Carp qw(fatalsToBrowser);

#ライブラリのロード
#require './lib/jcode.pl';
require './lib/html_lib.pl';
require './lib/temp_lib.pl';


#=====================================================================
#  初期ルーチン                                                     
#=====================================================================
&decode;

## コマンド振り分け
if ($mode eq "submit") { &sendmail;               }
if ($mode eq "check" ) { &check_form;             }
if ($mode eq "return") { &regi_form;              }
else                   { &data_init; &regi_form;  }
exit;


#=====================================================================
#  初期表示                                                     
#=====================================================================
sub regi_form {


	## ヘッダー
	print "Content-type: text/html; charset=UTF-8\n\n";
	&htmlHeader;

	## 入力フォーム
	print <<_HTML_;
		<div class="section">
			<h3>お問合せ</h3>
			<p>株式会社アセンドのホームページをご覧いただき、誠にありがとうございます。<br>
				ご質問、ご意見などがございましたら、お気軽にお問い合わせください。</p>
		</div>
		
		<div class="section">
			<h4><span>お電話・ファックスでのお問い合わせ</span></h4>
			
			<p><strong>TEL：029-282-1145&nbsp;&nbsp;FAX：029-282-7341</strong><br>
				受付時間 8:00～17:00 ※土日、祝日は不在となります。<br><br>
				<strong>ファックスでのお問い合わせ</strong><br>
			送信用紙に『氏名・ご連絡先・お問い合わせ内容』 をご明記ください。確認後、担当よりご連絡させていただきます。</p>
		</div>
		
		<div class="section">
			<h4><span>インターネットでのお問い合わせ</span></h4>
		<form name="form" method="post" action="$owncgi">
		<table border="0" cellpadding="0" cellspacing="0" class="contact_table">
		<tr>
		<th>お名前<br><span class="red">【必須】</span></th>
		<td>$err_name
		<input type="text" name="NAME" size="40" maxlength="40" style="ime-mode: active;" value="$form{'NAME'}" placeholder="例）山田 太郎" class="middle"></td></tr>

		<tr>
		<th>お名前（フリガナ）<br><span class="red">【必須】</span></th>
		<td>$err_kana
		<input type="text" name="KANA" size="40" maxlength="40" style="ime-mode: active;" value="$form{'KANA'}" placeholder="例）ヤマダ タロウ" class="middle"></td></tr>

		<tr>
		<th>会社名又は学校名<br><span class="red">【必須】</span></th>
		<td>$err_company
		<input type="text" name="COMPANY" size="40" maxlength="40" style="ime-mode: active;" value="$form{'COMPANY'}" placeholder="例）株式会社アセンド 又は &#9675;&#9675;大学" class="long"></td></tr>

		<tr>
		<th>部署又は学部・学科<br><span class="red">【必須】</span></th>
		<td>$err_division
		<input type="text" name="DIVISION" size="40" maxlength="40" style="ime-mode: active;" value="$form{'DIVISION'}" placeholder="例）総務部 又は &#9651;&#9651;学部&#x2610;&#x2610;学科" class="long"></td></tr>
		
		<tr>
		<th>郵便番号</th>
		<td>$err_post
		<input type="text" name="POST" size="40" maxlength="40" style="ime-mode: active;" value="$form{'POST'}" placeholder="半角数字" class="short">（ハイフン不要）</td></tr>

		<tr>
		<th>ご住所<br><span class="red">【必須】</span></th>
		<td>$err_address
		<input type="text" name="ADDRESS" size="40" maxlength="40" style="ime-mode: active;" value="$form{'ADDRESS'}" class="long"></td></tr>
		
		<tr>
		<th>電話番号</th>
		<td>$err_tel
		<input type="text" name="TEL" size="40" maxlength="40" style="ime-mode: active;" value="$form{'TEL'}" placeholder="半角数字" class="middle"></td></tr>

		<tr>
		<th>ファックス番号</th>
		<td>
		<input type="text" name="FAX" size="40" maxlength="40" style="ime-mode: active;" value="$form{'FAX'}" placeholder="半角数字" class="middle"></td></tr>

		<tr>
		<th>Eメールアドレス<br><span class="red">【必須】</span></th>
		<td>$err_email
		<input type="text" name="MAILADDRESS" size="25" maxlength="50" value="$form{'MAILADDRESS'}" placeholder="半角数字" class="long"></td></tr>
		
		<tr>
		<th>お問合せ事項<br><span class="red">【必須】</span></th>
		<td>$err_list
			<select name="LIST">
				<option value="" selected>選択してください</option>
				<option value="営業案内に関するお問い合わせ">営業案内に関するお問い合わせ</option>
				<option value="採用に関するお問い合わせ">採用に関するお問い合わせ</option>
				<option value="その他">その他</option>
			</select></td></tr>
		
		<tr>
		<th>お問合せ内容</th>
		<td><textarea name="MESSAGE" cols="60" rows="5" style="ime-mode: active;">$form{'MESSAGE'}</textarea></td></tr>
		</table>

		<p class="input_btn">
			<input type="submit" value="リセット">
			<input type="submit" name="C_CHECK" value="入力内容の確認">
		</p>
		</form>
		</div>
_HTML_

	&htmlFooter;
	exit;
}


#=====================================================================
#  確認画面表示                                                     
#=====================================================================
sub check_form {

	## 入力チェック
	my $ERR = 0;
	if (($form{'POST'} ne "") && ($form{'POST'} =~ /[^0-9\-]+/)      ) { $err_post     = "<span class=\"red\">入力内容が正しくありません。</span><br>";                $ERR = 1; }
	if (!$form{'POST'}                                               ) { $err_post     = "<span class=\"red\">郵便番号の省略は出来ません。</span><br>";                $ERR = 1; }
	if (!$form{'ADDRESS'}                                            ) { $err_address = "<span class=\"red\">住所の省略は出来ません。</span><br>";                $ERR = 1; }
	if (!$form{'LIST'}                                               ) { $err_list     = "<span class=\"red\">お問合せ内容の省略は出来ません。</span><br>";                $ERR = 1; }
	if (!$form{'NAME'}                                               ) { $err_name     = "<span class=\"red\">お名前の省略は出来ません。</span><br>";                $ERR = 1; }
	if (!$form{'KANA'}                                               ) { $err_kana     = "<span class=\"red\">ふりがなの省略は出来ません。</span><br>";                $ERR = 1; }

	if (!$form{'COMPANY'}                                            ) { $err_company      = "<span class=\"red\">会社名又は学校名の省略は出来ません。</span><br>";                $ERR = 1; }
	if (!$form{'DIVISION'}                                         ) { $err_division      = "<span class=\"red\">部署又は学部・学科の省略は出来ません。</span><br>";                $ERR = 1; }
	if (!$form{'MAILADDRESS'}                                         ) { $err_email  = "<span class=\"red\">メールアドレスの省略は出来ません。</span><br>";                $ERR = 1; }
	if (($form{'TEL'} ne "") && ($form{'TEL'} =~ /[^0-9\-]+/)        ) { $err_tel      = "<span class=\"red\">入力内容が正しくありません。</span><br>";                $ERR = 1; }

	#my$mailview2;
	#if(!$form{'EMAIL1'} || !$form{'EMAIL2'}){
	#	$err_email = "<FONT color=\"red\">メールアドレスの省略は出来ません。</FONT><br>";
	#	$ERR = 1;
	#}
	if($form{'MAILADDRESS'}){
		$mailview2 = $form{'MAILADDRESS'};
		if (($mailview2 ne '@') && ($mailview2 !~ /(.*)\@(.*)\.(.*)/)) { $err_email    = "<span class=\"red\">入力内容が正しくありません。</span><br>";          $ERR = 1; }
	}

	if($ERR == 1) { &regi_form; }


	## 入力確認画面の表示
	
	my $content   = $form{'LIST'};
	my $mesview = $form{'MESSAGE'};
	$mesview =~ s/\r\n/<br>/g;
	$mesview =~ s/\r/<br>/g;
	$mesview =~ s/\n/<br>/g;

	## ヘッダー
	print "Content-type: text/html; charset=UTF-8\n\n";
	&htmlHeader;

	## 入力確認フォーム
	print <<_HTML_;
		<form name="form" method="post" action="$owncgi">
		<table border="0" cellpadding="0" cellspacing="0" class="contact_table">

		<tr>
		<th>お名前<br><span class="red">【必須】</span></th>
		<td>$form{'NAME'}
		<input name="NAME" type="hidden" value="$form{'NAME'}"></td></tr>

		<tr>
		<th>お名前（フリガナ）<br><span class="red">【必須】</span></th>
		<td>$form{'KANA'}
		<input name="KANA" type="hidden" value="$form{'KANA'}"></td></tr>

		<tr>
		<th>会社名又は学校名<br><span class="red">【必須】</span></th>
		<td>$form{'COMPANY'}
		<input name="COMPANY" type="hidden" value="$form{'COMPANY'}"></td></tr>

		<tr>
		<th>部署又は学部・学科<br><span class="red">【必須】</span></th>
		<td>$form{'DIVISION'}
		<input name="DIVISION" type="hidden" value="$form{'DIVISION'}"></td></tr>

		<tr>
		<th>郵便番号</th>
		<td>$form{'POST'}
		<input name="POST" type="hidden" value="$form{'POST'}"></td></tr>

		<tr>
		<th>ご住所<br><span class="red">【必須】</span></th>
		<td>$form{'ADDRESS'}
		<input name="ADDRESS" type="hidden" value="$form{'ADDRESS'}"></td></tr>

		<tr>
		<th>電話番号</th>
		<td>$form{'TEL'}
		<input name="TEL" type="hidden" value="$form{'TEL'}"></td></tr>

		<tr>
		<th>ファックス番号</th>
		<td>$form{'FAX'}
		<input name="FAX" type="hidden" value="$form{'FAX'}"></td></tr>

		<tr>
		<th>Eメールアドレス<br><span class="red">【必須】</span></th>
		<td>$form{'MAILADDRESS'}
		<input name="MAILADDRESS" type="hidden" value="$form{'MAILADDRESS'}"></td></tr>

		<tr>
		<th>お問合せ事項<br><span class="red">【必須】</span></th>
		<td>$form{'LIST'}
		<input name="LIST" type="hidden" value="$form{'LIST'}"></td></tr>

		<tr>
		<th>お問合せ内容</th>
		<td>$mesview&nbsp;
		<input name="MESSAGE" type="hidden" value="$form{'MESSAGE'}"></td></tr>
		</table>

		<p class="input_btn">
			<input type="submit" name="C_RETURN" value="入力フォームへ戻る">
			<input type="submit" name="C_SUBMIT" value="内容を確認して送信">
		</p>
		</form>
_HTML_


	&htmlFooter;
	exit;
}

#-------------------------------------------------#
#  XSS対策
#-------------------------------------------------#
sub xss {
	my $str = shift || return(undef);

	$str =~ s/&/&amp;/g;
	$str =~ s/</&lt;/g;
	$str =~ s/>/&gt;/g;
	$str =~ s/\"/&quot;/g;
	$str =~ s/\'/&#39;/g;

	return($str);
}

#=====================================================================
#  メールの送信                                                       
#=====================================================================
sub sendmail {
	&get_time;
	
	#問合せ内容と問合せ先設定
	if ($form{'LIST'} eq "営業案内に関するお問い合わせ"){$adfmail = $mailList[0]; $subject = $titleList[0]};	
	if ($form{'LIST'} eq "採用に関するお問い合わせ"){$adfmail = $mailList[1]; $subject = $titleList[1]};
	if ($form{'LIST'} eq "その他")    {$adfmail = $mailList[2];  $subject = $titleList[2]};

	my $mailview2;
	if($form{'MAILADDRESS'}){
		$mailview2 = $form{'MAILADDRESS'};
	}

	$body = <<_BODY_;
==================================================================================
　　　　　　　		　	【お問合せ情報 】
==================================================================================
─────────────────────────────────────────
ホームページ上からお問合せがありました。
─────────────────────────────────────────

応募日時:$date $hour

お名前：  $form{'NAME'}　様

フリガナ：  $form{'KANA'}　サマ

会社名又は学校名：  $form{'COMPANY'}

部署又は学部・学科：  $form{'DIVISION'}

郵便番号：  $form{'POST'}

ご住所：   $form{'ADDRESS'}

電話番号：　　$form{'TEL'}

ファックス番号：　　$form{'FAX'}

E-mailアドレス：  $form{'MAILADDRESS'}

お問合せ事項：  $form{'LIST'}

お問合せ内容
$form{'MESSAGE'}


==================================================================================
_BODY_

# 	&jcode'convert(*body ,'jis');
	# UTF-8コード変換
 	my $enc = guess_encoding ( $body );
	my $from = $enc->name;
	my $to   = "jis";
 	from_to ( $body , $from , $to ); 

	# $subjectのコードを文字化け防止用に再変換
	$subject = Encode::encode('MIME-Header-ISO_2022_JP', $subject);
	
#	&jcode'convert(*subject ,'jis');
	# UTF-8コード変換
 	#my $enc = guess_encoding ( $subject );
	#my $from = $enc->name;
	#my $to   = "jis";
 	#from_to ( $subject , $from , $to ); 

	if ( !open( MAIL, "| $sendmail -t" ) ) { &error( 'メール送信システムが異常です。' ); }

	print MAIL "X-Mailer: Stdio iNDEX Web Mailer \n";
	print MAIL "To: $adfmail\n";
	print MAIL "From: $mailview2\n";
	print MAIL "Subject: $subject\n\n";
	print MAIL "$body";
	print MAIL "\n";

	close( MAIL );

	$body2 = <<_BODY_;
==================================================================================
　　　　　　　【株式会社アセンド　お問合せ内容のご確認 】
==================================================================================
─────────────────────────────────────────
このメールはサーバより自動的に送信されています。
─────────────────────────────────────────

このたびは、株式会社アセンドにお問合せいただき誠にありがとうございます。

心当たりの無い方が受信されました場合には下記のアドレスまでご連絡をお願いいたします。

※当メールは等幅フォントで作成しております。
  プロポーショナルフォントでは位置がずれることがありますのでご注意ください。
==================================================================================
$date $hourにご入力いただいた応募内容をご確認ください。

お名前：  $form{'NAME'}　様

フリガナ：  $form{'KANA'}　サマ

会社名又は学校名：  $form{'COMPANY'}

部署又は学部・学科：  $form{'DIVISION'}

郵便番号：  $form{'POST'}

ご住所：   $form{'ADDRESS'}

電話番号：　　$form{'TEL'}

ファックス番号：　　$form{'FAX'}

E-mailアドレス：  $form{'MAILADDRESS'}

お問合せ事項：  $form{'LIST'}

お問合せ内容
$form{'MESSAGE'}

==================================================================================
【お問合せ先】
お問合せに関するご質問等は下記メールアドレスにお送りください。
info\@ascend.co.jp

お問合せ先：株式会社アセンド
  〒319-1112　茨城県那珂郡東海村村松3115-6

  URL：https://www.ascend.co.jp/
  E-mail：info\@ascend.co.jp
  TEL：029-282-1145／FAX：029-282-7341
==================================================================================
_BODY_

#	&jcode'convert(*body2 ,'jis');
 		# UTF-8コード変換
 	my $enc = guess_encoding ( $body2 );
	my $from = $enc->name;
	my $to   = "jis";
 	from_to ( $body2 , $from , $to );
	
	
	#&jcode'convert(*subject2 ,'jis');

	# $subjectのコードを文字化け防止用に再変換
	$subject2 = Encode::encode('MIME-Header-ISO_2022_JP', $subject2);

	if($mailview2){
		if ( !open( MAIL, "| $sendmail -t" ) ) { &error( 'メール送信システムが異常です。' ); }
	
		print MAIL "X-Mailer: Stdio iNDEX Web Mailer \n";
		print MAIL "To: $mailview2\n";
		print MAIL "From: $adfmail\n";
		print MAIL "Subject: $subject2\n\n";
		print MAIL "$body2";
		print MAIL "\n";
	
		close( MAIL );
	}

	print "Content-type: text/html; charset=UTF-8\n\n";
	$reflashhtml = "<meta http-equiv=\"Refresh\" content=\"10;URL=$owncgi\">\n";
	&htmlHeader;
	print <<_HTML_;
			<p>お問合せいただき誠にありがとうございます。<br>
			確認のメールをご入力いただいたメールアドレスにお送りしておりますのでご確認ください。<br>
			後日、弊社担当者よりご連絡させていただきます。<br>
			10秒後に入力ページへ戻ります。<br>
			<br>
			戻らないときは、「<A href="$owncgi">ここ</A>」をクリックしてください。
			<br><br><br></p>
_HTML_
	&htmlFooter;
	exit;
}
